procedure page_13;

var
  i : $00..$2B;
  xbyte : byte;
  xchar : char;
  xFCB : array[$00..$2B] of byte;
  xlong : longint;
  xstring : string;
  xword1 : word;
  xword2 : word;

begin
  caption2('LASTDRIVE');
  drvname(lastdrv - 1);
  writeln;
  caption2('Logical drives');
  with regs do begin
    for xchar:='A' to 'Z' do begin
      AH:=$0E;
      DL:=ord(xchar) - ord('A');
      MSDOS(regs);
      AH:=$19;
      MSDOS(regs);
      if AL = DL then
        drvname(AL)
    end;
    writeln;
    AH:=$0E;
    DL:=currdrv;
    MSDOS(regs)
  end;
  caption2('Diskette drives');
  if equip and $0001 = $0001 then
    writeln(1 + equip and $00C0 shr 6)
  else
    writeln(0);
  xword1:=longint(intvec[$1E]) shr 16;
  xword2:=longint(intvec[$1E]) and $0000FFFF;
  caption3('Sectors/track');
  writeln(mem[xword1 : xword2 + 4]);
  caption3('Bytes/sector');
  writeln(mem[xword1 : xword2 + 3] shl 8);
  caption3('On time (ms)');
  writeln(125 * mem[xword1 : xword2 + 10]);
  caption3('Off time (s)');
  writeln(longint(mem[xword1 : xword2 + 2]) shl 16 / tick1 : 0 : 1);
  caption3('Head settle time (ms)');
  writeln(mem[xword1 : xword2 + 9]);
  caption1('  Single drive is now ');
  xbyte:=mem[BIOSdseg : $0104];
  if xbyte <= ord('Z') - ord('A') then begin
    drvname(xbyte);
    writeln
  end else if xbyte = $FF then
    writeln('N/A')
  else
    unknown('status', xbyte, 2);
(*  Byte 12:12 p.178  *)
  caption2('Current drive and path');
  getdir(0, xstring);
  writeln(xstring);
  caption3('Volume label');
  for i:=$00 to $2B do
    xFCB[i]:=$00;
  xFCB[$00]:=$FF;         (* extended FCB *)
  xFCB[$06]:=$08;         (* volume ID attribute *)
  for i:=$08 to $12 do
    xFCB[i]:=ord('?');
  with regs do begin
    AH:=$11;
    DS:=seg(xFCB);
    DX:=ofs(xFCB);
    MSDOS(regs);
    case AL of
      $00 : begin
        AH:=$2F;
        MSDOS(regs);
        i:=$08;
        xchar:=char(mem[ES : BX + i]);
        while (i <= $12) and (xchar > #0) do begin
          write(showchar(xchar));
          inc(i);
          xchar:=char(mem[ES : BX + i])
        end;
        writeln
      end;
      $FF : writeln('(none)')
      else
        unknown('status', AL, 2)
    end
  end;
  with regs do begin
    AH:=$1B;
    MSDOS(regs);
    media(mem[DS : BX], AL);
    caption3('Clusters');
    writeln(DX);
    caption3('Sectors/cluster');
    writeln(AL);
    caption3('Bytes/sector');
    writeln(CX)
  end;
  caption3('Total space (bytes)');
  xlong:=disksize(0);
  if xlong <> -1 then
    writeln(xlong : 8)
  else
    writeln('(invalid drive)');
  caption3('Free space (bytes) ');
  xlong:=diskfree(0);
  if xlong <> -1 then
    writeln(xlong : 8)
  else
    writeln('(invalid drive)')
end;
